/** @license
The MIT License (MIT)

Copyright (c) 2016 Marijn Haverbeke <marijnh@gmail.com> and others
Copyright (c) 2016 Michael Zhou <zhoumotongxue008@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
'use strict';(function(k){"object"==typeof exports&&"object"==typeof module?k(require("../../lib/codemirror"),require("../xml/xml"),require("../meta")):"function"==typeof define&&define.amd?define(["../../lib/codemirror","../xml/xml","../meta"],k):k(CodeMirror)})(function(k){k.defineMode("markdown",function(y,d){function x(b,a,c){a.f=a.inline=c;return c(b,a)}function z(b){b.linkTitle=!1;b.linkHref=!1;b.linkText=!1;b.em=!1;b.strong=!1;b.strikethrough=!1;b.quote=0;b.indentedCode=!1;b.f==r&&(b.f=l,b.block=
n);b.trailingSpace=0;b.trailingSpaceNewLine=!1;b.prevLine=b.thisLine;b.thisLine={stream:null};return null}function n(b,a){var c=b.column()===a.indentation,g=a.prevLine.stream;var t=!g||!/\S/.test(g.string);var l=a.indentedCode,h=a.prevLine.hr,m=!1!==a.list,p=(a.listStack[a.listStack.length-1]||0)+3;a.indentedCode=!1;g=a.indentation;if(null===a.indentationDiff&&(a.indentationDiff=a.indentation,m)){a.em=!1;a.strong=!1;a.code=!1;a.strikethrough=!1;for(a.list=null;g<a.listStack[a.listStack.length-1];)a.listStack.pop(),
a.listStack.length?a.indentation=a.listStack[a.listStack.length-1]:a.list=!1;!1!==a.list&&(a.indentationDiff=g-a.listStack[a.listStack.length-1])}var q=!t&&!h&&!a.prevLine.header&&(!m||!l)&&!a.prevLine.fencedCodeEnd,r=(!1===a.list||h||t)&&a.indentation<=p&&b.match(E);h=null;if(4<=a.indentationDiff&&(l||a.prevLine.fencedCodeEnd||a.prevLine.header||t))return b.skipToEnd(),a.indentedCode=!0,e.code;if(b.eatSpace())return null;if(c&&a.indentation<=p&&(h=b.match(F))&&6>=h[1].length)return a.quote=0,a.header=
h[1].length,a.thisLine.header=!0,d.highlightFormatting&&(a.formatting="header"),a.f=a.inline,f(a);if(a.indentation<=p&&b.eat(">"))return a.quote=c?1:a.quote+1,d.highlightFormatting&&(a.formatting="quote"),b.eatSpace(),f(a);if(!r&&!a.setext&&c&&a.indentation<=p&&(h=b.match(G)))return c=h[1]?"ol":"ul",a.indentation=g+b.current().length,a.list=!0,a.quote=0,a.listStack.push(a.indentation),d.taskLists&&b.match(A,!1)&&(a.taskList=!0),a.f=a.inline,d.highlightFormatting&&(a.formatting=["list","list-"+c]),
f(a);if(c&&a.indentation<=p&&(h=b.match(H,!0))){a.quote=0;a.fencedEndRE=new RegExp(h[1]+"+ *$");if(b=d.fencedCodeBlockHighlighting)b=h[2],k.findModeByName&&(c=k.findModeByName(b))&&(b=c.mime||c.mimes[0]),b=k.getMode(y,b),b="null"==b.name?null:b;a.localMode=b;a.localMode&&(a.localState=k.startState(a.localMode));a.f=a.block=I;d.highlightFormatting&&(a.formatting="code-block");a.code=-1;return f(a)}return a.setext||!(q&&m||a.quote||!1!==a.list||a.code||r||J.test(b.string))&&(h=b.lookAhead(1))&&(h=h.match(K))?
(a.setext?(a.header=a.setext,a.setext=0,b.skipToEnd(),d.highlightFormatting&&(a.formatting="header")):(a.header="="==h[0].charAt(0)?1:2,a.setext=a.header),a.thisLine.header=!0,a.f=a.inline,f(a)):r?(b.skipToEnd(),a.hr=!0,a.thisLine.hr=!0,e.hr):"["===b.peek()?x(b,a,L):x(b,a,a.inline)}function r(b,a){var c=m.token(b,a.htmlState);if(!M){var d=k.innerMode(m,a.htmlState);if("xml"==d.mode.name&&null===d.state.tagStart&&!d.state.context&&d.state.tokenize.isInText||a.md_inside&&-1<b.current().indexOf(">"))a.f=
l,a.block=n,a.htmlState=null}return c}function I(b,a){var c=a.listStack[a.listStack.length-1]||0,g=a.indentation<c;if(a.fencedEndRE&&a.indentation<=c+3&&(g||b.match(a.fencedEndRE))){d.highlightFormatting&&(a.formatting="code-block");var k;g||(k=f(a));a.localMode=a.localState=null;a.block=n;a.f=l;a.fencedEndRE=null;a.code=0;a.thisLine.fencedCodeEnd=!0;return g?(c=a.block,a.f=a.block=c,c(b,a)):k}if(a.localMode)return a.localMode.token(b,a.localState);b.skipToEnd();return e.code}function f(b){var a=
[];if(b.formatting){a.push(e.formatting);"string"===typeof b.formatting&&(b.formatting=[b.formatting]);for(var c=0;c<b.formatting.length;c++)a.push(e.formatting+"-"+b.formatting[c]),"header"===b.formatting[c]&&a.push(e.formatting+"-"+b.formatting[c]+"-"+b.header),"quote"===b.formatting[c]&&(!d.maxBlockquoteDepth||d.maxBlockquoteDepth>=b.quote?a.push(e.formatting+"-"+b.formatting[c]+"-"+b.quote):a.push("error"))}if(b.taskOpen)return a.push("meta"),a.length?a.join(" "):null;if(b.taskClosed)return a.push("property"),
a.length?a.join(" "):null;b.linkHref?a.push(e.linkHref,"url"):(b.strong&&a.push(e.strong),b.em&&a.push(e.em),b.strikethrough&&a.push(e.strikethrough),b.emoji&&a.push(e.emoji),b.linkText&&a.push(e.linkText),b.code&&a.push(e.code),b.image&&a.push(e.image),b.imageAltText&&a.push(e.imageAltText,"link"),b.imageMarker&&a.push(e.imageMarker));b.header&&a.push(e.header,e.header+"-"+b.header);b.quote&&(a.push(e.quote),!d.maxBlockquoteDepth||d.maxBlockquoteDepth>=b.quote?a.push(e.quote+"-"+b.quote):a.push(e.quote+
"-"+d.maxBlockquoteDepth));!1!==b.list&&((c=(b.listStack.length-1)%3)?1===c?a.push(e.list2):a.push(e.list3):a.push(e.list1));b.trailingSpaceNewLine?a.push("trailing-space-new-line"):b.trailingSpace&&a.push("trailing-space-"+(b.trailingSpace%2?"a":"b"));return a.length?a.join(" "):null}function N(b,a){if(b.match(O,!0))return f(a)}function l(b,a){var c=a.text(b,a);if("undefined"!==typeof c)return c;if(a.list)return a.list=null,f(a);if(a.taskList)return" "===b.match(A,!0)[1]?a.taskOpen=!0:a.taskClosed=
!0,d.highlightFormatting&&(a.formatting="task"),a.taskList=!1,f(a);a.taskOpen=!1;a.taskClosed=!1;if(a.header&&b.match(/^#+$/,!0))return d.highlightFormatting&&(a.formatting="header"),f(a);c=b.next();if(a.linkTitle){a.linkTitle=!1;var g=c;"("===c&&(g=")");g=(g+"").replace(/([.?*+^\[\]\\(){}|-])/g,"\\$1");if(b.match(new RegExp("^\\s*(?:[^"+g+"\\\\]+|\\\\\\\\|\\\\.)"+g),!0))return e.linkHref}if("`"===c){c=a.formatting;d.highlightFormatting&&(a.formatting="code");b.eatWhile("`");b=b.current().length;
if(0!=a.code||a.quote&&1!=b){if(b==a.code)return b=f(a),a.code=0,b;a.formatting=c;return f(a)}a.code=b;return f(a)}if(a.code)return f(a);if("\\"===c&&(b.next(),d.highlightFormatting))return c=f(a),a=e.formatting+"-escape",c?c+" "+a:a;if("!"===c&&b.match(/\[[^\]]*\] ?(?:\(|\[)/,!1))return a.imageMarker=!0,a.image=!0,d.highlightFormatting&&(a.formatting="image"),f(a);if("["===c&&a.imageMarker&&b.match(/[^\]]*\](\(.*?\)| ?\[.*?\])/,!1))return a.imageMarker=!1,a.imageAltText=!0,d.highlightFormatting&&
(a.formatting="image"),f(a);if("]"===c&&a.imageAltText)return d.highlightFormatting&&(a.formatting="image"),c=f(a),a.imageAltText=!1,a.image=!1,a.inline=a.f=B,c;if("["===c&&!a.image)return a.linkText=!0,d.highlightFormatting&&(a.formatting="link"),f(a);if("]"===c&&a.linkText)return d.highlightFormatting&&(a.formatting="link"),c=f(a),a.linkText=!1,a.inline=a.f=b.match(/\(.*?\)| ?\[.*?\]/,!1)?B:l,c;if("<"===c&&b.match(/^(https?|ftps?):\/\/(?:[^\\>]|\\.)+>/,!1))return a.f=a.inline=C,d.highlightFormatting&&
(a.formatting="link"),c=f(a),(c?c+" ":"")+e.linkInline;if("<"===c&&b.match(/^[^> \\]+@(?:[^\\>]|\\.)+>/,!1))return a.f=a.inline=C,d.highlightFormatting&&(a.formatting="link"),c=f(a),(c?c+" ":"")+e.linkEmail;if(d.xml&&"<"===c&&b.match(/^(!--|[a-z][a-z0-9-]*(?:\s+[a-z_:.\-]+(?:\s*=\s*[^>]+)?)*\s*>)/i,!1))return c=b.string.indexOf(">",b.pos),-1!=c&&(c=b.string.substring(b.start,c),/markdown\s*=\s*('|"){0,1}1('|"){0,1}/.test(c)&&(a.md_inside=!0)),b.backUp(1),a.htmlState=k.startState(m),c=r,a.f=a.block=
c,c(b,a);if(d.xml&&"<"===c&&b.match(/^\/\w*?>/))return a.md_inside=!1,"tag";if("*"===c||"_"===c){for(var t=1,u=1==b.pos?" ":b.string.charAt(b.pos-2);3>t&&b.eat(c);)t++;var h=b.peek()||" ",n=!/\s/.test(h)&&(!q.test(h)||/\s/.test(u)||q.test(u)),p=!/\s/.test(u)&&(!q.test(u)||/\s/.test(h)||q.test(h)),v=g=null;t%2&&(a.em||!n||"*"!==c&&p&&!q.test(u)?a.em!=c||!p||"*"!==c&&n&&!q.test(h)||(g=!1):g=!0);1<t&&(a.strong||!n||"*"!==c&&p&&!q.test(u)?a.strong!=c||!p||"*"!==c&&n&&!q.test(h)||(v=!1):v=!0);if(null!=
v||null!=g)return d.highlightFormatting&&(a.formatting=null==g?"strong":null==v?"em":"strong em"),!0===g&&(a.em=c),!0===v&&(a.strong=c),b=f(a),!1===g&&(a.em=!1),!1===v&&(a.strong=!1),b}else if(" "===c&&(b.eat("*")||b.eat("_"))){if(" "===b.peek())return f(a);b.backUp(1)}if(d.strikethrough)if("~"===c&&b.eatWhile(c)){if(a.strikethrough)return d.highlightFormatting&&(a.formatting="strikethrough"),b=f(a),a.strikethrough=!1,b;if(b.match(/^[^\s]/,!1))return a.strikethrough=!0,d.highlightFormatting&&(a.formatting=
"strikethrough"),f(a)}else if(" "===c&&b.match(/^~~/,!0)){if(" "===b.peek())return f(a);b.backUp(2)}if(d.emoji&&":"===c&&b.match(/^[a-z_\d+-]+:/))return a.emoji=!0,d.highlightFormatting&&(a.formatting="emoji"),b=f(a),a.emoji=!1,b;" "===c&&(b.match(/ +$/,!1)?a.trailingSpace++:a.trailingSpace&&(a.trailingSpaceNewLine=!0));return f(a)}function C(b,a){if(">"===b.next())return a.f=a.inline=l,d.highlightFormatting&&(a.formatting="link"),b=f(a),(b?b+" ":"")+e.linkInline;b.match(/^[^>]+/,!0);return e.linkInline}
function B(b,a){if(b.eatSpace())return null;b=b.next();return"("===b||"["===b?(a.f=a.inline=P("("===b?")":"]"),d.highlightFormatting&&(a.formatting="link-string"),a.linkHref=!0,f(a)):"error"}function P(b){return function(a,c){if(a.next()===b)return c.f=c.inline=l,d.highlightFormatting&&(c.formatting="link-string"),a=f(c),c.linkHref=!1,a;a.match(Q[b]);c.linkHref=!0;return f(c)}}function L(b,a){return b.match(/^([^\]\\]|\\.)*\]:/,!1)?(a.f=R,b.next(),d.highlightFormatting&&(a.formatting="link"),a.linkText=
!0,f(a)):x(b,a,l)}function R(b,a){if(b.match(/^\]:/,!0))return a.f=a.inline=S,d.highlightFormatting&&(a.formatting="link"),b=f(a),a.linkText=!1,b;b.match(/^([^\]\\]|\\.)+/,!0);return e.linkText}function S(b,a){if(b.eatSpace())return null;b.match(/^[^\s]+/,!0);void 0===b.peek()?a.linkTitle=!0:b.match(/^(?:\s+(?:"(?:[^"\\]|\\\\|\\.)+"|'(?:[^'\\]|\\\\|\\.)+'|\((?:[^)\\]|\\\\|\\.)+\)))?/,!0);a.f=a.inline=l;return e.linkHref+" url"}var m=k.getMode(y,"text/html"),M="null"==m.name;void 0===d.highlightFormatting&&
(d.highlightFormatting=!1);void 0===d.maxBlockquoteDepth&&(d.maxBlockquoteDepth=0);void 0===d.taskLists&&(d.taskLists=!1);void 0===d.strikethrough&&(d.strikethrough=!1);void 0===d.emoji&&(d.emoji=!1);void 0===d.fencedCodeBlockHighlighting&&(d.fencedCodeBlockHighlighting=!0);void 0===d.xml&&(d.xml=!0);void 0===d.tokenTypeOverrides&&(d.tokenTypeOverrides={});var e={header:"header",code:"comment",quote:"quote",list1:"variable-2",list2:"variable-3",list3:"keyword",hr:"hr",image:"image",imageAltText:"image-alt-text",
imageMarker:"image-marker",formatting:"formatting",linkInline:"link",linkEmail:"link",linkText:"link",linkHref:"string",em:"em",strong:"strong",strikethrough:"strikethrough",emoji:"builtin"},w;for(w in e)e.hasOwnProperty(w)&&d.tokenTypeOverrides[w]&&(e[w]=d.tokenTypeOverrides[w]);var E=/^([*\-_])(?:\s*\1){2,}\s*$/,G=/^(?:[*\-+]|^[0-9]+([.)]))\s+/,A=/^\[(x| )\](?=\s)/i,F=d.allowAtxHeaderWithoutSpace?/^(#+)/:/^(#+)(?: |$)/,K=/^ *(?:={1,}|-{1,})\s*$/,O=/^[^#!\[\]*_\\<>` "'(~:]+/,H=/^(~~~+|```+)[ \t]*([\w+#-]*)[^\n`]*$/,
J=/^\s*\[[^\]]+?\]:.*$/,q=/[!"#$%&'()*+,\-\.\/:;<=>?@\[\\\]^_`{|}~\u2014]/,Q={")":/^(?:[^\\\(\)]|\\.|\((?:[^\\\(\)]|\\.)*\))*?(?=\))/,"]":/^(?:[^\\\[\]]|\\.|\[(?:[^\\\[\]]|\\.)*\])*?(?=\])/},D={startState:function(){return{f:n,prevLine:{stream:null},thisLine:{stream:null},block:n,htmlState:null,indentation:0,inline:l,text:N,formatting:!1,linkText:!1,linkHref:!1,linkTitle:!1,code:0,em:!1,strong:!1,header:0,setext:0,hr:!1,taskList:!1,list:!1,listStack:[],quote:0,trailingSpace:0,trailingSpaceNewLine:!1,
strikethrough:!1,emoji:!1,fencedEndRE:null}},copyState:function(b){return{f:b.f,prevLine:b.prevLine,thisLine:b.thisLine,block:b.block,htmlState:b.htmlState&&k.copyState(m,b.htmlState),indentation:b.indentation,localMode:b.localMode,localState:b.localMode?k.copyState(b.localMode,b.localState):null,inline:b.inline,text:b.text,formatting:!1,linkText:b.linkText,linkTitle:b.linkTitle,linkHref:b.linkHref,code:b.code,em:b.em,strong:b.strong,strikethrough:b.strikethrough,emoji:b.emoji,header:b.header,setext:b.setext,
hr:b.hr,taskList:b.taskList,list:b.list,listStack:b.listStack.slice(0),quote:b.quote,indentedCode:b.indentedCode,trailingSpace:b.trailingSpace,trailingSpaceNewLine:b.trailingSpaceNewLine,md_inside:b.md_inside,fencedEndRE:b.fencedEndRE}},token:function(b,a){a.formatting=!1;if(b!=a.thisLine.stream){a.header=0;a.hr=!1;if(b.match(/^\s*$/,!0))return z(a),null;a.prevLine=a.thisLine;a.thisLine={stream:b};a.taskList=!1;a.trailingSpace=0;a.trailingSpaceNewLine=!1;if(!a.localState&&(a.f=a.block,a.f!=r)){var c=
b.match(/^\s*/,!0)[0].replace(/\t/g,"    ").length;a.indentation=c;a.indentationDiff=null;if(0<c)return null}}return a.f(b,a)},innerMode:function(b){return b.block==r?{state:b.htmlState,mode:m}:b.localState?{state:b.localState,mode:b.localMode}:{state:b,mode:D}},indent:function(b,a,c){return b.block==r&&m.indent?m.indent(b.htmlState,a,c):b.localState&&b.localMode.indent?b.localMode.indent(b.localState,a,c):k.Pass},blankLine:z,getType:f,closeBrackets:"()[]{}''\"\"``",fold:"markdown"};return D},"xml");
k.defineMIME("text/markdown","markdown");k.defineMIME("text/x-markdown","markdown")});
