/** @license
The MIT License (MIT)

Copyright (c) 2016 Marijn Haverbeke <marijnh@gmail.com> and others
Copyright (c) 2016 Michael Zhou <zhoumotongxue008@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

// The google-diff-match-patch library is from https://repo1.maven.org/maven2/org/webjars/google-diff-match-patch/20121119-1/google-diff-match-patch-20121119-1.jar

/** @license
LICENSE-Apache2.0
*/
(function(){function diff_match_patch(){this.Diff_Timeout=1;this.Diff_EditCost=4;this.Match_Threshold=0.5;this.Match_Distance=1E3;this.Patch_DeleteThreshold=0.5;this.Patch_Margin=4;this.Match_MaxBits=32}
diff_match_patch.prototype.diff_main=function(a,b,c,d){"undefined"==typeof d&&(d=0>=this.Diff_Timeout?Number.MAX_VALUE:(new Date).getTime()+1E3*this.Diff_Timeout);if(null==a||null==b)throw Error("Null input. (diff_main)");if(a==b)return a?[[0,a]]:[];"undefined"==typeof c&&(c=!0);var e=c,f=this.diff_commonPrefix(a,b);c=a.substring(0,f);a=a.substring(f);b=b.substring(f);var f=this.diff_commonSuffix(a,b),g=a.substring(a.length-f);a=a.substring(0,a.length-f);b=b.substring(0,b.length-f);a=this.diff_compute_(a,
b,e,d);c&&a.unshift([0,c]);g&&a.push([0,g]);this.diff_cleanupMerge(a);return a};
diff_match_patch.prototype.diff_compute_=function(a,b,c,d){if(!a)return[[1,b]];if(!b)return[[-1,a]];var e=a.length>b.length?a:b,f=a.length>b.length?b:a,g=e.indexOf(f);return-1!=g?(c=[[1,e.substring(0,g)],[0,f],[1,e.substring(g+f.length)]],a.length>b.length&&(c[0][0]=c[2][0]=-1),c):1==f.length?[[-1,a],[1,b]]:(e=this.diff_halfMatch_(a,b))?(f=e[0],a=e[1],g=e[2],b=e[3],e=e[4],f=this.diff_main(f,g,c,d),c=this.diff_main(a,b,c,d),f.concat([[0,e]],c)):c&&100<a.length&&100<b.length?this.diff_lineMode_(a,b,
d):this.diff_bisect_(a,b,d)};
diff_match_patch.prototype.diff_lineMode_=function(a,b,c){var d=this.diff_linesToChars_(a,b);a=d.chars1;b=d.chars2;d=d.lineArray;a=this.diff_main(a,b,!1,c);this.diff_charsToLines_(a,d);this.diff_cleanupSemantic(a);a.push([0,""]);for(var e=d=b=0,f="",g="";b<a.length;){switch(a[b][0]){case 1:e++;g+=a[b][1];break;case -1:d++;f+=a[b][1];break;case 0:if(1<=d&&1<=e){a.splice(b-d-e,d+e);b=b-d-e;d=this.diff_main(f,g,!1,c);for(e=d.length-1;0<=e;e--)a.splice(b,0,d[e]);b+=d.length}d=e=0;g=f=""}b++}a.pop();return a};
diff_match_patch.prototype.diff_bisect_=function(a,b,c){for(var d=a.length,e=b.length,f=Math.ceil((d+e)/2),g=f,h=2*f,j=Array(h),i=Array(h),k=0;k<h;k++)j[k]=-1,i[k]=-1;j[g+1]=0;i[g+1]=0;for(var k=d-e,q=0!=k%2,r=0,t=0,p=0,w=0,v=0;v<f&&!((new Date).getTime()>c);v++){for(var n=-v+r;n<=v-t;n+=2){var l=g+n,m;m=n==-v||n!=v&&j[l-1]<j[l+1]?j[l+1]:j[l-1]+1;for(var s=m-n;m<d&&s<e&&a.charAt(m)==b.charAt(s);)m++,s++;j[l]=m;if(m>d)t+=2;else if(s>e)r+=2;else if(q&&(l=g+k-n,0<=l&&l<h&&-1!=i[l])){var u=d-i[l];if(m>=
u)return this.diff_bisectSplit_(a,b,m,s,c)}}for(n=-v+p;n<=v-w;n+=2){l=g+n;u=n==-v||n!=v&&i[l-1]<i[l+1]?i[l+1]:i[l-1]+1;for(m=u-n;u<d&&m<e&&a.charAt(d-u-1)==b.charAt(e-m-1);)u++,m++;i[l]=u;if(u>d)w+=2;else if(m>e)p+=2;else if(!q&&(l=g+k-n,0<=l&&(l<h&&-1!=j[l])&&(m=j[l],s=g+m-l,u=d-u,m>=u)))return this.diff_bisectSplit_(a,b,m,s,c)}}return[[-1,a],[1,b]]};
diff_match_patch.prototype.diff_bisectSplit_=function(a,b,c,d,e){var f=a.substring(0,c),g=b.substring(0,d);a=a.substring(c);b=b.substring(d);f=this.diff_main(f,g,!1,e);e=this.diff_main(a,b,!1,e);return f.concat(e)};
diff_match_patch.prototype.diff_linesToChars_=function(a,b){function c(a){for(var b="",c=0,f=-1,g=d.length;f<a.length-1;){f=a.indexOf("\n",c);-1==f&&(f=a.length-1);var r=a.substring(c,f+1),c=f+1;(e.hasOwnProperty?e.hasOwnProperty(r):void 0!==e[r])?b+=String.fromCharCode(e[r]):(b+=String.fromCharCode(g),e[r]=g,d[g++]=r)}return b}var d=[],e={};d[0]="";var f=c(a),g=c(b);return{chars1:f,chars2:g,lineArray:d}};
diff_match_patch.prototype.diff_charsToLines_=function(a,b){for(var c=0;c<a.length;c++){for(var d=a[c][1],e=[],f=0;f<d.length;f++)e[f]=b[d.charCodeAt(f)];a[c][1]=e.join("")}};diff_match_patch.prototype.diff_commonPrefix=function(a,b){if(!a||!b||a.charAt(0)!=b.charAt(0))return 0;for(var c=0,d=Math.min(a.length,b.length),e=d,f=0;c<e;)a.substring(f,e)==b.substring(f,e)?f=c=e:d=e,e=Math.floor((d-c)/2+c);return e};
diff_match_patch.prototype.diff_commonSuffix=function(a,b){if(!a||!b||a.charAt(a.length-1)!=b.charAt(b.length-1))return 0;for(var c=0,d=Math.min(a.length,b.length),e=d,f=0;c<e;)a.substring(a.length-e,a.length-f)==b.substring(b.length-e,b.length-f)?f=c=e:d=e,e=Math.floor((d-c)/2+c);return e};
diff_match_patch.prototype.diff_commonOverlap_=function(a,b){var c=a.length,d=b.length;if(0==c||0==d)return 0;c>d?a=a.substring(c-d):c<d&&(b=b.substring(0,c));c=Math.min(c,d);if(a==b)return c;for(var d=0,e=1;;){var f=a.substring(c-e),f=b.indexOf(f);if(-1==f)return d;e+=f;if(0==f||a.substring(c-e)==b.substring(0,e))d=e,e++}};
diff_match_patch.prototype.diff_halfMatch_=function(a,b){function c(a,b,c){for(var d=a.substring(c,c+Math.floor(a.length/4)),e=-1,g="",h,j,n,l;-1!=(e=b.indexOf(d,e+1));){var m=f.diff_commonPrefix(a.substring(c),b.substring(e)),s=f.diff_commonSuffix(a.substring(0,c),b.substring(0,e));g.length<s+m&&(g=b.substring(e-s,e)+b.substring(e,e+m),h=a.substring(0,c-s),j=a.substring(c+m),n=b.substring(0,e-s),l=b.substring(e+m))}return 2*g.length>=a.length?[h,j,n,l,g]:null}if(0>=this.Diff_Timeout)return null;
var d=a.length>b.length?a:b,e=a.length>b.length?b:a;if(4>d.length||2*e.length<d.length)return null;var f=this,g=c(d,e,Math.ceil(d.length/4)),d=c(d,e,Math.ceil(d.length/2)),h;if(!g&&!d)return null;h=d?g?g[4].length>d[4].length?g:d:d:g;var j;a.length>b.length?(g=h[0],d=h[1],e=h[2],j=h[3]):(e=h[0],j=h[1],g=h[2],d=h[3]);h=h[4];return[g,d,e,j,h]};
diff_match_patch.prototype.diff_cleanupSemantic=function(a){for(var b=!1,c=[],d=0,e=null,f=0,g=0,h=0,j=0,i=0;f<a.length;)0==a[f][0]?(c[d++]=f,g=j,h=i,i=j=0,e=a[f][1]):(1==a[f][0]?j+=a[f][1].length:i+=a[f][1].length,e&&(e.length<=Math.max(g,h)&&e.length<=Math.max(j,i))&&(a.splice(c[d-1],0,[-1,e]),a[c[d-1]+1][0]=1,d--,d--,f=0<d?c[d-1]:-1,i=j=h=g=0,e=null,b=!0)),f++;b&&this.diff_cleanupMerge(a);this.diff_cleanupSemanticLossless(a);for(f=1;f<a.length;){if(-1==a[f-1][0]&&1==a[f][0]){b=a[f-1][1];c=a[f][1];
d=this.diff_commonOverlap_(b,c);e=this.diff_commonOverlap_(c,b);if(d>=e){if(d>=b.length/2||d>=c.length/2)a.splice(f,0,[0,c.substring(0,d)]),a[f-1][1]=b.substring(0,b.length-d),a[f+1][1]=c.substring(d),f++}else if(e>=b.length/2||e>=c.length/2)a.splice(f,0,[0,b.substring(0,e)]),a[f-1][0]=1,a[f-1][1]=c.substring(0,c.length-e),a[f+1][0]=-1,a[f+1][1]=b.substring(e),f++;f++}f++}};
diff_match_patch.prototype.diff_cleanupSemanticLossless=function(a){function b(a,b){if(!a||!b)return 6;var c=a.charAt(a.length-1),d=b.charAt(0),e=c.match(diff_match_patch.nonAlphaNumericRegex_),f=d.match(diff_match_patch.nonAlphaNumericRegex_),g=e&&c.match(diff_match_patch.whitespaceRegex_),h=f&&d.match(diff_match_patch.whitespaceRegex_),c=g&&c.match(diff_match_patch.linebreakRegex_),d=h&&d.match(diff_match_patch.linebreakRegex_),i=c&&a.match(diff_match_patch.blanklineEndRegex_),j=d&&b.match(diff_match_patch.blanklineStartRegex_);
return i||j?5:c||d?4:e&&!g&&h?3:g||h?2:e||f?1:0}for(var c=1;c<a.length-1;){if(0==a[c-1][0]&&0==a[c+1][0]){var d=a[c-1][1],e=a[c][1],f=a[c+1][1],g=this.diff_commonSuffix(d,e);if(g)var h=e.substring(e.length-g),d=d.substring(0,d.length-g),e=h+e.substring(0,e.length-g),f=h+f;for(var g=d,h=e,j=f,i=b(d,e)+b(e,f);e.charAt(0)===f.charAt(0);){var d=d+e.charAt(0),e=e.substring(1)+f.charAt(0),f=f.substring(1),k=b(d,e)+b(e,f);k>=i&&(i=k,g=d,h=e,j=f)}a[c-1][1]!=g&&(g?a[c-1][1]=g:(a.splice(c-1,1),c--),a[c][1]=
h,j?a[c+1][1]=j:(a.splice(c+1,1),c--))}c++}};diff_match_patch.nonAlphaNumericRegex_=/[^a-zA-Z0-9]/;diff_match_patch.whitespaceRegex_=/\s/;diff_match_patch.linebreakRegex_=/[\r\n]/;diff_match_patch.blanklineEndRegex_=/\n\r?\n$/;diff_match_patch.blanklineStartRegex_=/^\r?\n\r?\n/;
diff_match_patch.prototype.diff_cleanupEfficiency=function(a){for(var b=!1,c=[],d=0,e=null,f=0,g=!1,h=!1,j=!1,i=!1;f<a.length;){if(0==a[f][0])a[f][1].length<this.Diff_EditCost&&(j||i)?(c[d++]=f,g=j,h=i,e=a[f][1]):(d=0,e=null),j=i=!1;else if(-1==a[f][0]?i=!0:j=!0,e&&(g&&h&&j&&i||e.length<this.Diff_EditCost/2&&3==g+h+j+i))a.splice(c[d-1],0,[-1,e]),a[c[d-1]+1][0]=1,d--,e=null,g&&h?(j=i=!0,d=0):(d--,f=0<d?c[d-1]:-1,j=i=!1),b=!0;f++}b&&this.diff_cleanupMerge(a)};
diff_match_patch.prototype.diff_cleanupMerge=function(a){a.push([0,""]);for(var b=0,c=0,d=0,e="",f="",g;b<a.length;)switch(a[b][0]){case 1:d++;f+=a[b][1];b++;break;case -1:c++;e+=a[b][1];b++;break;case 0:1<c+d?(0!==c&&0!==d&&(g=this.diff_commonPrefix(f,e),0!==g&&(0<b-c-d&&0==a[b-c-d-1][0]?a[b-c-d-1][1]+=f.substring(0,g):(a.splice(0,0,[0,f.substring(0,g)]),b++),f=f.substring(g),e=e.substring(g)),g=this.diff_commonSuffix(f,e),0!==g&&(a[b][1]=f.substring(f.length-g)+a[b][1],f=f.substring(0,f.length-
g),e=e.substring(0,e.length-g))),0===c?a.splice(b-d,c+d,[1,f]):0===d?a.splice(b-c,c+d,[-1,e]):a.splice(b-c-d,c+d,[-1,e],[1,f]),b=b-c-d+(c?1:0)+(d?1:0)+1):0!==b&&0==a[b-1][0]?(a[b-1][1]+=a[b][1],a.splice(b,1)):b++,c=d=0,f=e=""}""===a[a.length-1][1]&&a.pop();c=!1;for(b=1;b<a.length-1;)0==a[b-1][0]&&0==a[b+1][0]&&(a[b][1].substring(a[b][1].length-a[b-1][1].length)==a[b-1][1]?(a[b][1]=a[b-1][1]+a[b][1].substring(0,a[b][1].length-a[b-1][1].length),a[b+1][1]=a[b-1][1]+a[b+1][1],a.splice(b-1,1),c=!0):a[b][1].substring(0,
a[b+1][1].length)==a[b+1][1]&&(a[b-1][1]+=a[b+1][1],a[b][1]=a[b][1].substring(a[b+1][1].length)+a[b+1][1],a.splice(b+1,1),c=!0)),b++;c&&this.diff_cleanupMerge(a)};diff_match_patch.prototype.diff_xIndex=function(a,b){var c=0,d=0,e=0,f=0,g;for(g=0;g<a.length;g++){1!==a[g][0]&&(c+=a[g][1].length);-1!==a[g][0]&&(d+=a[g][1].length);if(c>b)break;e=c;f=d}return a.length!=g&&-1===a[g][0]?f:f+(b-e)};
diff_match_patch.prototype.diff_prettyHtml=function(a){for(var b=[],c=/&/g,d=/</g,e=/>/g,f=/\n/g,g=0;g<a.length;g++){var h=a[g][0],j=a[g][1],j=j.replace(c,"&amp;").replace(d,"&lt;").replace(e,"&gt;").replace(f,"&para;<br>");switch(h){case 1:b[g]='<ins style="background:#e6ffe6;">'+j+"</ins>";break;case -1:b[g]='<del style="background:#ffe6e6;">'+j+"</del>";break;case 0:b[g]="<span>"+j+"</span>"}}return b.join("")};
diff_match_patch.prototype.diff_text1=function(a){for(var b=[],c=0;c<a.length;c++)1!==a[c][0]&&(b[c]=a[c][1]);return b.join("")};diff_match_patch.prototype.diff_text2=function(a){for(var b=[],c=0;c<a.length;c++)-1!==a[c][0]&&(b[c]=a[c][1]);return b.join("")};diff_match_patch.prototype.diff_levenshtein=function(a){for(var b=0,c=0,d=0,e=0;e<a.length;e++){var f=a[e][0],g=a[e][1];switch(f){case 1:c+=g.length;break;case -1:d+=g.length;break;case 0:b+=Math.max(c,d),d=c=0}}return b+=Math.max(c,d)};
diff_match_patch.prototype.diff_toDelta=function(a){for(var b=[],c=0;c<a.length;c++)switch(a[c][0]){case 1:b[c]="+"+encodeURI(a[c][1]);break;case -1:b[c]="-"+a[c][1].length;break;case 0:b[c]="="+a[c][1].length}return b.join("\t").replace(/%20/g," ")};
diff_match_patch.prototype.diff_fromDelta=function(a,b){for(var c=[],d=0,e=0,f=b.split(/\t/g),g=0;g<f.length;g++){var h=f[g].substring(1);switch(f[g].charAt(0)){case "+":try{c[d++]=[1,decodeURI(h)]}catch(j){throw Error("Illegal escape in diff_fromDelta: "+h);}break;case "-":case "=":var i=parseInt(h,10);if(isNaN(i)||0>i)throw Error("Invalid number in diff_fromDelta: "+h);h=a.substring(e,e+=i);"="==f[g].charAt(0)?c[d++]=[0,h]:c[d++]=[-1,h];break;default:if(f[g])throw Error("Invalid diff operation in diff_fromDelta: "+
f[g]);}}if(e!=a.length)throw Error("Delta length ("+e+") does not equal source text length ("+a.length+").");return c};diff_match_patch.prototype.match_main=function(a,b,c){if(null==a||null==b||null==c)throw Error("Null input. (match_main)");c=Math.max(0,Math.min(c,a.length));return a==b?0:a.length?a.substring(c,c+b.length)==b?c:this.match_bitap_(a,b,c):-1};
diff_match_patch.prototype.match_bitap_=function(a,b,c){function d(a,d){var e=a/b.length,g=Math.abs(c-d);return!f.Match_Distance?g?1:e:e+g/f.Match_Distance}if(b.length>this.Match_MaxBits)throw Error("Pattern too long for this browser.");var e=this.match_alphabet_(b),f=this,g=this.Match_Threshold,h=a.indexOf(b,c);-1!=h&&(g=Math.min(d(0,h),g),h=a.lastIndexOf(b,c+b.length),-1!=h&&(g=Math.min(d(0,h),g)));for(var j=1<<b.length-1,h=-1,i,k,q=b.length+a.length,r,t=0;t<b.length;t++){i=0;for(k=q;i<k;)d(t,c+
k)<=g?i=k:q=k,k=Math.floor((q-i)/2+i);q=k;i=Math.max(1,c-k+1);var p=Math.min(c+k,a.length)+b.length;k=Array(p+2);for(k[p+1]=(1<<t)-1;p>=i;p--){var w=e[a.charAt(p-1)];k[p]=0===t?(k[p+1]<<1|1)&w:(k[p+1]<<1|1)&w|((r[p+1]|r[p])<<1|1)|r[p+1];if(k[p]&j&&(w=d(t,p-1),w<=g))if(g=w,h=p-1,h>c)i=Math.max(1,2*c-h);else break}if(d(t+1,c)>g)break;r=k}return h};
diff_match_patch.prototype.match_alphabet_=function(a){for(var b={},c=0;c<a.length;c++)b[a.charAt(c)]=0;for(c=0;c<a.length;c++)b[a.charAt(c)]|=1<<a.length-c-1;return b};
diff_match_patch.prototype.patch_addContext_=function(a,b){if(0!=b.length){for(var c=b.substring(a.start2,a.start2+a.length1),d=0;b.indexOf(c)!=b.lastIndexOf(c)&&c.length<this.Match_MaxBits-this.Patch_Margin-this.Patch_Margin;)d+=this.Patch_Margin,c=b.substring(a.start2-d,a.start2+a.length1+d);d+=this.Patch_Margin;(c=b.substring(a.start2-d,a.start2))&&a.diffs.unshift([0,c]);(d=b.substring(a.start2+a.length1,a.start2+a.length1+d))&&a.diffs.push([0,d]);a.start1-=c.length;a.start2-=c.length;a.length1+=
c.length+d.length;a.length2+=c.length+d.length}};
diff_match_patch.prototype.patch_make=function(a,b,c){var d;if("string"==typeof a&&"string"==typeof b&&"undefined"==typeof c)d=a,b=this.diff_main(d,b,!0),2<b.length&&(this.diff_cleanupSemantic(b),this.diff_cleanupEfficiency(b));else if(a&&"object"==typeof a&&"undefined"==typeof b&&"undefined"==typeof c)b=a,d=this.diff_text1(b);else if("string"==typeof a&&b&&"object"==typeof b&&"undefined"==typeof c)d=a;else if("string"==typeof a&&"string"==typeof b&&c&&"object"==typeof c)d=a,b=c;else throw Error("Unknown call format to patch_make.");
if(0===b.length)return[];c=[];a=new diff_match_patch.patch_obj;for(var e=0,f=0,g=0,h=d,j=0;j<b.length;j++){var i=b[j][0],k=b[j][1];!e&&0!==i&&(a.start1=f,a.start2=g);switch(i){case 1:a.diffs[e++]=b[j];a.length2+=k.length;d=d.substring(0,g)+k+d.substring(g);break;case -1:a.length1+=k.length;a.diffs[e++]=b[j];d=d.substring(0,g)+d.substring(g+k.length);break;case 0:k.length<=2*this.Patch_Margin&&e&&b.length!=j+1?(a.diffs[e++]=b[j],a.length1+=k.length,a.length2+=k.length):k.length>=2*this.Patch_Margin&&
e&&(this.patch_addContext_(a,h),c.push(a),a=new diff_match_patch.patch_obj,e=0,h=d,f=g)}1!==i&&(f+=k.length);-1!==i&&(g+=k.length)}e&&(this.patch_addContext_(a,h),c.push(a));return c};diff_match_patch.prototype.patch_deepCopy=function(a){for(var b=[],c=0;c<a.length;c++){var d=a[c],e=new diff_match_patch.patch_obj;e.diffs=[];for(var f=0;f<d.diffs.length;f++)e.diffs[f]=d.diffs[f].slice();e.start1=d.start1;e.start2=d.start2;e.length1=d.length1;e.length2=d.length2;b[c]=e}return b};
diff_match_patch.prototype.patch_apply=function(a,b){if(0==a.length)return[b,[]];a=this.patch_deepCopy(a);var c=this.patch_addPadding(a);b=c+b+c;this.patch_splitMax(a);for(var d=0,e=[],f=0;f<a.length;f++){var g=a[f].start2+d,h=this.diff_text1(a[f].diffs),j,i=-1;if(h.length>this.Match_MaxBits){if(j=this.match_main(b,h.substring(0,this.Match_MaxBits),g),-1!=j&&(i=this.match_main(b,h.substring(h.length-this.Match_MaxBits),g+h.length-this.Match_MaxBits),-1==i||j>=i))j=-1}else j=this.match_main(b,h,g);
if(-1==j)e[f]=!1,d-=a[f].length2-a[f].length1;else if(e[f]=!0,d=j-g,g=-1==i?b.substring(j,j+h.length):b.substring(j,i+this.Match_MaxBits),h==g)b=b.substring(0,j)+this.diff_text2(a[f].diffs)+b.substring(j+h.length);else if(g=this.diff_main(h,g,!1),h.length>this.Match_MaxBits&&this.diff_levenshtein(g)/h.length>this.Patch_DeleteThreshold)e[f]=!1;else{this.diff_cleanupSemanticLossless(g);for(var h=0,k,i=0;i<a[f].diffs.length;i++){var q=a[f].diffs[i];0!==q[0]&&(k=this.diff_xIndex(g,h));1===q[0]?b=b.substring(0,
j+k)+q[1]+b.substring(j+k):-1===q[0]&&(b=b.substring(0,j+k)+b.substring(j+this.diff_xIndex(g,h+q[1].length)));-1!==q[0]&&(h+=q[1].length)}}}b=b.substring(c.length,b.length-c.length);return[b,e]};
diff_match_patch.prototype.patch_addPadding=function(a){for(var b=this.Patch_Margin,c="",d=1;d<=b;d++)c+=String.fromCharCode(d);for(d=0;d<a.length;d++)a[d].start1+=b,a[d].start2+=b;var d=a[0],e=d.diffs;if(0==e.length||0!=e[0][0])e.unshift([0,c]),d.start1-=b,d.start2-=b,d.length1+=b,d.length2+=b;else if(b>e[0][1].length){var f=b-e[0][1].length;e[0][1]=c.substring(e[0][1].length)+e[0][1];d.start1-=f;d.start2-=f;d.length1+=f;d.length2+=f}d=a[a.length-1];e=d.diffs;0==e.length||0!=e[e.length-1][0]?(e.push([0,
c]),d.length1+=b,d.length2+=b):b>e[e.length-1][1].length&&(f=b-e[e.length-1][1].length,e[e.length-1][1]+=c.substring(0,f),d.length1+=f,d.length2+=f);return c};
diff_match_patch.prototype.patch_splitMax=function(a){for(var b=this.Match_MaxBits,c=0;c<a.length;c++)if(!(a[c].length1<=b)){var d=a[c];a.splice(c--,1);for(var e=d.start1,f=d.start2,g="";0!==d.diffs.length;){var h=new diff_match_patch.patch_obj,j=!0;h.start1=e-g.length;h.start2=f-g.length;""!==g&&(h.length1=h.length2=g.length,h.diffs.push([0,g]));for(;0!==d.diffs.length&&h.length1<b-this.Patch_Margin;){var g=d.diffs[0][0],i=d.diffs[0][1];1===g?(h.length2+=i.length,f+=i.length,h.diffs.push(d.diffs.shift()),
j=!1):-1===g&&1==h.diffs.length&&0==h.diffs[0][0]&&i.length>2*b?(h.length1+=i.length,e+=i.length,j=!1,h.diffs.push([g,i]),d.diffs.shift()):(i=i.substring(0,b-h.length1-this.Patch_Margin),h.length1+=i.length,e+=i.length,0===g?(h.length2+=i.length,f+=i.length):j=!1,h.diffs.push([g,i]),i==d.diffs[0][1]?d.diffs.shift():d.diffs[0][1]=d.diffs[0][1].substring(i.length))}g=this.diff_text2(h.diffs);g=g.substring(g.length-this.Patch_Margin);i=this.diff_text1(d.diffs).substring(0,this.Patch_Margin);""!==i&&
(h.length1+=i.length,h.length2+=i.length,0!==h.diffs.length&&0===h.diffs[h.diffs.length-1][0]?h.diffs[h.diffs.length-1][1]+=i:h.diffs.push([0,i]));j||a.splice(++c,0,h)}}};diff_match_patch.prototype.patch_toText=function(a){for(var b=[],c=0;c<a.length;c++)b[c]=a[c];return b.join("")};
diff_match_patch.prototype.patch_fromText=function(a){var b=[];if(!a)return b;a=a.split("\n");for(var c=0,d=/^@@ -(\d+),?(\d*) \+(\d+),?(\d*) @@$/;c<a.length;){var e=a[c].match(d);if(!e)throw Error("Invalid patch string: "+a[c]);var f=new diff_match_patch.patch_obj;b.push(f);f.start1=parseInt(e[1],10);""===e[2]?(f.start1--,f.length1=1):"0"==e[2]?f.length1=0:(f.start1--,f.length1=parseInt(e[2],10));f.start2=parseInt(e[3],10);""===e[4]?(f.start2--,f.length2=1):"0"==e[4]?f.length2=0:(f.start2--,f.length2=
parseInt(e[4],10));for(c++;c<a.length;){e=a[c].charAt(0);try{var g=decodeURI(a[c].substring(1))}catch(h){throw Error("Illegal escape in patch_fromText: "+g);}if("-"==e)f.diffs.push([-1,g]);else if("+"==e)f.diffs.push([1,g]);else if(" "==e)f.diffs.push([0,g]);else if("@"==e)break;else if(""!==e)throw Error('Invalid patch mode "'+e+'" in: '+g);c++}}return b};diff_match_patch.patch_obj=function(){this.diffs=[];this.start2=this.start1=null;this.length2=this.length1=0};
diff_match_patch.patch_obj.prototype.toString=function(){var a,b;a=0===this.length1?this.start1+",0":1==this.length1?this.start1+1:this.start1+1+","+this.length1;b=0===this.length2?this.start2+",0":1==this.length2?this.start2+1:this.start2+1+","+this.length2;a=["@@ -"+a+" +"+b+" @@\n"];var c;for(b=0;b<this.diffs.length;b++){switch(this.diffs[b][0]){case 1:c="+";break;case -1:c="-";break;case 0:c=" "}a[b+1]=c+encodeURI(this.diffs[b][1])+"\n"}return a.join("").replace(/%20/g," ")};
this.diff_match_patch=diff_match_patch;this.DIFF_DELETE=-1;this.DIFF_INSERT=1;this.DIFF_EQUAL=0;})()
;
'use strict';var $jscomp=$jscomp||{};$jscomp.scope={};$jscomp.findInternal=function(g,x,m){g instanceof String&&(g=String(g));for(var y=g.length,z=0;z<y;z++){var B=g[z];if(x.call(m,B,z,g))return{i:z,v:B}}return{i:-1,v:void 0}};$jscomp.ASSUME_ES5=!1;$jscomp.ASSUME_NO_NATIVE_MAP=!1;$jscomp.ASSUME_NO_NATIVE_SET=!1;$jscomp.defineProperty=$jscomp.ASSUME_ES5||"function"==typeof Object.defineProperties?Object.defineProperty:function(g,x,m){g!=Array.prototype&&g!=Object.prototype&&(g[x]=m.value)};
$jscomp.getGlobal=function(g){return"undefined"!=typeof window&&window===g?g:"undefined"!=typeof global&&null!=global?global:g};$jscomp.global=$jscomp.getGlobal(this);$jscomp.polyfill=function(g,x,m,y){if(x){m=$jscomp.global;g=g.split(".");for(y=0;y<g.length-1;y++){var z=g[y];z in m||(m[z]={});m=m[z]}g=g[g.length-1];y=m[g];x=x(y);x!=y&&null!=x&&$jscomp.defineProperty(m,g,{configurable:!0,writable:!0,value:x})}};
$jscomp.polyfill("Array.prototype.find",function(g){return g?g:function(g,m){return $jscomp.findInternal(this,g,m).v}},"es6","es3");
(function(g){"object"==typeof exports&&"object"==typeof module?g(require("../../lib/codemirror")):"function"==typeof define&&define.amd?define(["../../lib/codemirror","diff_match_patch"],g):g(CodeMirror)})(function(g){function x(a,b){this.mv=a;this.type=b;this.classes="left"==b?{chunk:"CodeMirror-merge-l-chunk",start:"CodeMirror-merge-l-chunk-start",end:"CodeMirror-merge-l-chunk-end",insert:"CodeMirror-merge-l-inserted",del:"CodeMirror-merge-l-deleted",connect:"CodeMirror-merge-l-connect"}:{chunk:"CodeMirror-merge-r-chunk",
start:"CodeMirror-merge-r-chunk-start",end:"CodeMirror-merge-r-chunk-end",insert:"CodeMirror-merge-r-inserted",del:"CodeMirror-merge-r-deleted",connect:"CodeMirror-merge-r-connect"}}function m(a){a.diffOutOfDate&&(a.diff=T(a.orig.getValue(),a.edit.getValue(),a.mv.options.ignoreWhitespace),a.chunks=U(a.diff),a.diffOutOfDate=!1,g.signal(a.edit,"updateDiff",a.diff))}function y(a){function b(b){G=!0;n=!1;"full"==b&&(a.svg&&H(a.svg),a.copyButtons&&H(a.copyButtons),L(a.edit,k.marked,a.classes),L(a.orig,
h.marked,a.classes),k.from=k.to=h.from=h.to=0);m(a);a.showDifferences&&(V(a.edit,a.diff,k,DIFF_INSERT,a.classes),V(a.orig,a.diff,h,DIFF_DELETE,a.classes));"align"==a.mv.options.connect&&M(a);C(a);null!=a.needsScrollSync&&B(a,a.needsScrollSync);G=!1}function c(b){G||(a.dealigned=!0,d(b))}function d(a){G||n||(clearTimeout(l),!0===a&&(n=!0),l=setTimeout(b,!0===a?20:250))}function f(b,d){a.diffOutOfDate||(a.diffOutOfDate=!0,k.from=k.to=h.from=h.to=0);c(d.text.length-1!=d.to.line-d.from.line)}function e(){a.diffOutOfDate=
!0;a.dealigned=!0;b("full")}var k={from:0,to:0,marked:[]},h={from:0,to:0,marked:[]},l,n=!1;a.edit.on("change",f);a.orig.on("change",f);a.edit.on("swapDoc",e);a.orig.on("swapDoc",e);"align"==a.mv.options.connect&&(g.on(a.edit.state.trackAlignable,"realign",c),g.on(a.orig.state.trackAlignable,"realign",c));a.edit.on("viewportChange",function(){d(!1)});a.orig.on("viewportChange",function(){d(!1)});b();return b}function z(a,b){a.edit.on("scroll",function(){B(a,!0)&&C(a)});a.orig.on("scroll",function(){B(a,
!1)&&C(a);b&&B(b,!0)&&C(b)})}function B(a,b){if(a.diffOutOfDate)return a.lockScroll&&null==a.needsScrollSync&&(a.needsScrollSync=b),!1;a.needsScrollSync=null;if(!a.lockScroll)return!0;var c=+new Date;if(b){var d=a.edit;var f=a.orig}else d=a.orig,f=a.edit;if(d.state.scrollSetBy==a&&(d.state.scrollSetAt||0)+250>c)return!1;var e=d.getScrollInfo();if("align"==a.mv.options.connect)w=e.top;else{var k=.5*e.clientHeight;w=e.top+k;var h=d.lineAtHeight(w,"local");for(var l=a.chunks,n,g,p,m=0;m<l.length;m++){var q=
l[m],v=b?q.editFrom:q.origFrom,r=b?q.editTo:q.origTo;null==g&&(v>h?(g=q.editFrom,p=q.origFrom):r>h&&(g=q.editTo,p=q.origTo));if(r<=h){n=q.editTo;var t=q.origTo}else v<=h&&(n=q.editFrom,t=q.origFrom)}h={before:n,after:g};t={before:t,after:p};d=W(d,b?h:t);b=W(f,b?t:h);var w=b.top-k+(w-d.top)/(d.bot-d.top)*(b.bot-b.top),F;w>e.top&&1>(F=e.top/k)?w=w*F+e.top*(1-F):(b=e.height-e.clientHeight-e.top)<k&&(d=f.getScrollInfo(),d.height-d.clientHeight-w>b&&1>(F=b/k)&&(w=w*F+(d.height-d.clientHeight-b)*(1-F)))}f.scrollTo(e.left,
w);f.state.scrollSetAt=c;f.state.scrollSetBy=a;return!0}function W(a,b){var c=b.after;null==c&&(c=a.lastLine()+1);return{top:a.heightAtLine(b.before||0,"local"),bot:a.heightAtLine(c,"local")}}function X(a,b,c){(a.lockScroll=b)&&0!=c&&B(a,DIFF_INSERT)&&C(a);(b?g.addClass:g.rmClass)(a.lockButton,"CodeMirror-merge-scrolllock-enabled")}function L(a,b,c){for(var d=0;d<b.length;++d){var f=b[d];if(f instanceof g.TextMarker)f.clear();else if(f.parent)for(var e=a,k=c,h=k.classLocation,l=0;l<h.length;l++)e.removeLineClass(f,
h[l],k.chunk),e.removeLineClass(f,h[l],k.start),e.removeLineClass(f,h[l],k.end)}b.length=0}function V(a,b,c,d,f){var e=a.getViewport();a.operation(function(){c.from==c.to||20<e.from-c.to||20<c.from-e.to?(L(a,c.marked,f),N(a,b,d,c.marked,e.from,e.to,f),c.from=e.from,c.to=e.to):(e.from<c.from&&(N(a,b,d,c.marked,e.from,c.from,f),c.from=e.from),e.to>c.to&&(N(a,b,d,c.marked,c.to,e.to,f),c.to=e.to))})}function O(a,b,c,d,f,e){var k=c.classLocation;b=a.getLineHandle(b);for(var h=0;h<k.length;h++)d&&a.addLineClass(b,
k[h],c.chunk),f&&a.addLineClass(b,k[h],c.start),e&&a.addLineClass(b,k[h],c.end);return b}function N(a,b,c,d,f,e,k){function h(b,c){for(var h=Math.max(f,b),l=Math.min(e,c),g=h;g<l;++g)d.push(O(a,g,k,!0,g==b,g==c-1));b==c&&h==c&&l==c&&(h?d.push(O(a,h-1,k,!1,!1,!0)):d.push(O(a,h,k,!1,!0,!1)))}for(var l=u(0,0),n=u(f,0),g=a.clipPos(u(e-1)),p=c==DIFF_DELETE?k.del:k.insert,m=0,q=!1,v=0;v<b.length;++v){var r=b[v],t=r[0];r=r[1];t==DIFF_EQUAL?(t=l.line+(Y(b,v)?0:1),I(l,r),r=l.line+(Z(b,v)?1:0),r>t&&(q&&(h(m,
t),q=!1),m=r)):(q=!0,t==c&&(t=I(l,r,!0),l=0<(n.line-l.line||n.ch-l.ch)?n:l,r=0>(g.line-t.line||g.ch-t.ch)?g:t,l.line==r.line&&l.ch==r.ch||d.push(a.markText(l,r,{className:p})),l=t))}q&&h(m,l.line+1)}function C(a){if(a.showDifferences){if(a.svg){H(a.svg);var b=a.gap.offsetWidth;aa(a.svg,"width",b,"height",a.gap.offsetHeight)}a.copyButtons&&H(a.copyButtons);var c=a.edit.getViewport(),d=a.orig.getViewport(),f=a.mv.wrap.getBoundingClientRect().top,e=f-a.edit.getScrollerElement().getBoundingClientRect().top+
a.edit.getScrollInfo().top;f=f-a.orig.getScrollerElement().getBoundingClientRect().top+a.orig.getScrollInfo().top;for(var k=0;k<a.chunks.length;k++){var h=a.chunks[k];if(h.editFrom<=c.to&&h.editTo>=c.from&&h.origFrom<=d.to&&h.origTo>=d.from){var l=a,g=f,E=e,p=b,m="left"==l.type,q=l.orig.heightAtLine(h.origFrom,"local",!0)-g;if(l.svg){var v=q,r=l.edit.heightAtLine(h.editFrom,"local",!0)-E;if(m){var t=v;v=r;r=t}g=l.orig.heightAtLine(h.origTo,"local",!0)-g;var w=l.edit.heightAtLine(h.editTo,"local",
!0)-E;m&&(t=g,g=w,w=t);m=" C "+p/2+" "+r+" "+p/2+" "+v+" "+(p+2)+" "+v;v=" C "+p/2+" "+g+" "+p/2+" "+w+" -1 "+w;aa(l.svg.appendChild(document.createElementNS("http://www.w3.org/2000/svg","path")),"d","M -1 "+r+m+" L "+(p+2)+" "+g+v+" z","class",l.classes.connect)}l.copyButtons&&(p=l.copyButtons.appendChild(A("div","left"==l.type?"\u21dd":"\u21dc","CodeMirror-merge-copy")),r=l.mv.options.allowEditingOriginals,p.title=r?"Push to left":"Revert chunk",p.chunk=h,p.style.top=(h.origTo>h.origFrom?q:l.edit.heightAtLine(h.editFrom,
"local")-E)+"px",r&&(E=l.edit.heightAtLine(h.editFrom,"local")-E,q=l.copyButtons.appendChild(A("div","right"==l.type?"\u21dd":"\u21dc","CodeMirror-merge-copy-reverse")),q.title="Push to right",q.chunk={editFrom:h.origFrom,editTo:h.origTo,origFrom:h.editFrom,origTo:h.editTo},q.style.top=E+"px","right"==l.type?q.style.left="2px":q.style.right="2px"))}}}}function ba(a,b){for(var c=0,d=0,f=0;f<b.length;f++){var e=b[f];if(e.editTo>a&&e.editFrom<=a)return null;if(e.editFrom>a)break;c=e.editTo;d=e.origTo}return d+
(a-c)}function P(a,b,c){var d=a.state.trackAlignable;a=a.firstLine();for(var f=0,e=[],k=0;;k++){for(var h=b[k],l=h?c?h.origFrom:h.editFrom:1E9;f<d.alignable.length;f+=2){var g=d.alignable[f]+1;if(!(g<=a))if(g<=l)e.push(g);else break}if(!h)break;e.push(a=c?h.origTo:h.editTo)}return e}function ca(a,b,c,d){var f=0,e=0,k=0,h=0;a:for(;;f++){var g=a[f],n=b[e];if(!g&&null==n)break;var m=g?g[0]:1E9;for(n=null==n?1E9:n;k<c.length;){var p=c[k];if(p.origFrom<=n&&p.origTo>n){e++;f--;continue a}if(p.editTo>m){if(p.editFrom<=
m)continue a;break}h+=p.origTo-p.origFrom-(p.editTo-p.editFrom);k++}m==n-h?(g[d]=n,e++):m<n-h?g[d]=m+h:(g=[n-h,null,null],g[d]=n,a.splice(f,0,g),e++)}}function ka(a,b){var c=P(a.edit,a.chunks,!1),d=[];if(b)for(var f=0,e=0;f<b.chunks.length;f++){for(var k=b.chunks[f].editTo;e<c.length&&c[e]<k;)e++;e!=c.length&&c[e]==k||c.splice(e++,0,k)}for(f=0;f<c.length;f++)d.push([c[f],null,null]);ca(d,P(a.orig,a.chunks,!0),a.chunks,1);b&&ca(d,P(b.orig,b.chunks,!0),b.chunks,2);return d}function M(a,b){if(a.dealigned||
b){if(!a.orig.curOp)return a.orig.operation(function(){M(a,b)});a.dealigned=!1;var c=a.mv.left==a?a.mv.right:a.mv.left;c&&(m(c),c.dealigned=!1);for(var d=ka(a,c),f=a.mv.aligners,e=0;e<f.length;e++)f[e].clear();f.length=0;var k=[a.edit,a.orig],h=[];c&&k.push(c.orig);for(e=0;e<k.length;e++)h.push(k[e].getScrollInfo().top);for(c=0;c<d.length;c++)la(k,d[c],f);for(e=0;e<k.length;e++)k[e].scrollTo(null,h[e])}}function la(a,b,c){for(var d=0,f=[],e=0;e<a.length;e++)if(null!=b[e]){var k=a[e].heightAtLine(b[e],
"local");f[e]=k;d=Math.max(d,k)}for(e=0;e<a.length;e++)null!=b[e]&&(k=d-f[e],1<k&&c.push(ma(a[e],b[e],k)))}function ma(a,b,c){var d=!0;b>a.lastLine()&&(b--,d=!1);var f=document.createElement("div");f.className="CodeMirror-merge-spacer";f.style.height=c+"px";f.style.minWidth="1px";return a.addLineWidget(b,f,{height:c,above:d,mergeSpacer:!0,handleMouseEvents:!0})}function da(a,b,c,d){if(!a.diffOutOfDate){var f=d.origTo>c.lastLine()?u(d.origFrom-1):u(d.origFrom,0),e=u(d.origTo,0),k=d.editTo>b.lastLine()?
u(d.editFrom-1):u(d.editFrom,0);d=u(d.editTo,0);var h=a.mv.options.revertChunk;h?h(a.mv,c,f,e,b,k,d):b.replaceRange(c.getRange(f,e),k,d)}}function ea(a){var b=a.lockButton=A("div",null,"CodeMirror-merge-scrolllock");b.title="Toggle locked scrolling";var c=A("div",[b],"CodeMirror-merge-scrolllock-wrap");g.on(b,"click",function(){X(a,!a.lockScroll)});b=[c];!1!==a.mv.options.revertButtons&&(a.copyButtons=A("div",null,"CodeMirror-merge-copybuttons-"+a.type),g.on(a.copyButtons,"click",function(b){b=b.target||
b.srcElement;b.chunk&&("CodeMirror-merge-copy-reverse"==b.className?da(a,a.orig,a.edit,b.chunk):da(a,a.edit,a.orig,b.chunk))}),b.unshift(a.copyButtons));"align"!=a.mv.options.connect&&((c=document.createElementNS&&document.createElementNS("http://www.w3.org/2000/svg","svg"))&&!c.createSVGRect&&(c=null),(a.svg=c)&&b.push(c));return a.gap=A("div",b,"CodeMirror-merge-gap")}function fa(a){return"string"==typeof a?a:a.getValue()}function T(a,b,c){Q||(Q=new diff_match_patch);a=Q.diff_main(a,b);for(b=0;b<
a.length;++b){var d=a[b];(c?/[^ \t]/.test(d[1]):d[1])?b&&a[b-1][0]==d[0]&&(a.splice(b--,1),a[b][1]+=d[1]):a.splice(b--,1)}return a}function U(a){var b=[];if(!a.length)return b;for(var c=0,d=0,f=u(0,0),e=u(0,0),k=0;k<a.length;++k){var h=a[k],g=h[0];if(g==DIFF_EQUAL){var n=!Y(a,k)||f.line<c||e.line<d?1:0;g=f.line+n;n=e.line+n;I(f,h[1],null,e);var m=Z(a,k)?1:0;h=f.line+m;m=e.line+m;h>g&&(k&&b.push({origFrom:d,origTo:n,editFrom:c,editTo:g}),c=h,d=m)}else I(g==DIFF_INSERT?f:e,h[1])}(c<=f.line||d<=e.line)&&
b.push({origFrom:d,origTo:e.line+1,editFrom:c,editTo:f.line+1});return b}function Z(a,b){if(b==a.length-1)return!0;var c=a[b+1][1];if(1==c.length&&b<a.length-2||10!=c.charCodeAt(0))return!1;if(b==a.length-2)return!0;c=a[b+2][1];return(1<c.length||b==a.length-3)&&10==c.charCodeAt(0)}function Y(a,b){if(0==b)return!0;var c=a[b-1][1];if(10!=c.charCodeAt(c.length-1))return!1;if(1==b)return!0;c=a[b-2][1];return 10==c.charCodeAt(c.length-1)}function na(a,b,c){function d(){e.clear();a.removeLineClass(b,"wrap",
"CodeMirror-merge-collapsed-line")}a.addLineClass(b,"wrap","CodeMirror-merge-collapsed-line");var f=document.createElement("span");f.className="CodeMirror-merge-collapsed-widget";f.title="Identical text collapsed. Click to expand.";var e=a.markText(u(b,0),u(c-1),{inclusiveLeft:!0,inclusiveRight:!0,replacedWith:f,clearOnEnter:!0});e.explicitlyCleared&&d();g.on(f,"click",d);e.on("clear",d);g.on(f,"click",d);return{mark:e,clear:d}}function oa(a,b){function c(){for(var a=0;a<d.length;a++)d[a].clear()}
for(var d=[],f=0;f<b.length;f++){var e=b[f];e=na(e.cm,e.line,e.line+a);d.push(e);e.mark.on("clear",c)}return d[0].mark}function ha(a,b,c,d){for(var f=0;f<a.chunks.length;f++)for(var e=a.chunks[f],g=e.editFrom-b;g<e.editTo+b;g++){var h=g+c;0<=h&&h<d.length&&(d[h]=!1)}}function A(a,b,c,d){a=document.createElement(a);c&&(a.className=c);d&&(a.style.cssText=d);if("string"==typeof b)a.appendChild(document.createTextNode(b));else if(b)for(c=0;c<b.length;++c)a.appendChild(b[c]);return a}function H(a){for(var b=
a.childNodes.length;0<b;--b)a.removeChild(a.firstChild)}function aa(a){for(var b=1;b<arguments.length;b+=2)a.setAttribute(arguments[b],arguments[b+1])}function R(a,b){b||(b={});for(var c in a)a.hasOwnProperty(c)&&(b[c]=a[c]);return b}function I(a,b,c,d){a=c?u(a.line,a.ch):a;for(c=0;;){var f=b.indexOf("\n",c);if(-1==f)break;++a.line;d&&++d.line;c=f+1}a.ch=(c?0:a.ch)+(b.length-c);d&&(d.ch=(c?0:d.ch)+(b.length-c));return a}function S(a){this.cm=a;this.alignable=[];this.height=a.doc.height;var b=this;
a.on("markerAdded",function(a,d){d.collapsed&&(a=d.find(1),null!=a&&b.set(a.line,J))});a.on("markerCleared",function(a,d,f,e){null!=e&&d.collapsed&&b.check(e,J,b.hasMarker)});a.on("markerChanged",this.signal.bind(this));a.on("lineWidgetAdded",function(a,d,f){d.mergeSpacer||(d.above?b.set(f-1,D):b.set(f,ia))});a.on("lineWidgetCleared",function(a,d,f){d.mergeSpacer||(d.above?b.check(f-1,D,b.hasWidgetBelow):b.check(f,ia,b.hasWidget))});a.on("lineWidgetChanged",this.signal.bind(this));a.on("change",function(a,
d){a=d.from.line;var c=d.to.line-d.from.line,e=d.text.length-1,g=a+e;(c||e)&&b.map(a,c,e);b.check(g,J,b.hasMarker);(c||e)&&b.check(d.from.line,J,b.hasMarker)});a.on("viewportChange",function(){b.cm.doc.height!=b.height&&b.signal()})}function ja(a,b){var c=null,d=a.state.diffViews,f=a.getCursor().line;if(d)for(var e=0;e<d.length;e++){var k=d[e],h=a==k.orig;m(k);if(0>b)a:{k=k.chunks;for(var l=k.length-1;0<=l;l--){var n=k[l];n=(h?n.origTo:n.editTo)-1;if(n<f){h=n;break a}}h=void 0}else a:{k=k.chunks;
for(l=0;l<k.length;l++)if(n=k[l],n=h?n.origFrom:n.editFrom,n>f){h=n;break a}h=void 0}null!=h&&(null==c||(0>b?h>c:h<c))&&(c=h)}if(null!=c)a.setCursor(c,0);else return g.Pass}var u=g.Pos;x.prototype={constructor:x,init:function(a,b,c){this.edit=this.mv.edit;(this.edit.state.diffViews||(this.edit.state.diffViews=[])).push(this);this.orig=g(a,R({value:b,readOnly:!this.mv.options.allowEditingOriginals},R(c)));"align"==this.mv.options.connect&&(this.edit.state.trackAlignable||(this.edit.state.trackAlignable=
new S(this.edit)),this.orig.state.trackAlignable=new S(this.orig));this.orig.state.diffViews=[this];a=c.chunkClassLocation||"background";"[object Array]"!=Object.prototype.toString.call(a)&&(a=[a]);this.classes.classLocation=a;this.diff=T(fa(b),fa(c.value),this.mv.options.ignoreWhitespace);this.chunks=U(this.diff);this.diffOutOfDate=this.dealigned=!1;this.needsScrollSync=null;this.showDifferences=!1!==c.showDifferences},registerEvents:function(a){this.forceUpdate=y(this);X(this,!0,!1);z(this,a)},
setShowDifferences:function(a){a=!1!==a;a!=this.showDifferences&&(this.showDifferences=a,this.forceUpdate("full"))}};var G=!1,K=g.MergeView=function(a,b){if(!(this instanceof K))return new K(a,b);this.options=b;var c=b.origLeft,d=null==b.origRight?b.orig:b.origRight,f=null!=c,e=null!=d,k=1+(f?1:0)+(e?1:0),h=[],l=this.left=null,n=this.right=null,m=this;if(f){l=this.left=new x(this,"left");var p=A("div",null,"CodeMirror-merge-pane CodeMirror-merge-left");h.push(p);h.push(ea(l))}f=A("div",null,"CodeMirror-merge-pane CodeMirror-merge-editor");
h.push(f);if(e){n=this.right=new x(this,"right");h.push(ea(n));var u=A("div",null,"CodeMirror-merge-pane CodeMirror-merge-right");h.push(u)}(e?u:f).className+=" CodeMirror-merge-pane-rightmost";h.push(A("div",null,null,"height: 0; clear: both;"));var q=this.wrap=a.appendChild(A("div",h,"CodeMirror-merge CodeMirror-merge-"+k+"pane"));this.edit=g(f,R(b));l&&l.init(p,c,b);n&&n.init(u,d,b);b.collapseIdentical&&this.editor().operation(function(){var a=b.collapseIdentical;"number"!=typeof a&&(a=2);for(var c=
[],d=m.editor(),e=d.firstLine(),f=e,h=d.lastLine();f<=h;f++)c.push(!0);m.left&&ha(m.left,a,e,c);m.right&&ha(m.right,a,e,c);for(f=0;f<c.length;f++)if(c[f]){h=f+e;for(var g=1;f<c.length-1&&c[f+1];f++,g++);if(g>a){var k=[{line:h,cm:d}];m.left&&k.push({line:ba(h,m.left.chunks),cm:m.left.orig});m.right&&k.push({line:ba(h,m.right.chunks),cm:m.right.orig});k=oa(g,k);if(m.options.onCollapse)m.options.onCollapse(m,h,g,k)}}});"align"==b.connect&&(this.aligners=[],M(this.left||this.right,!0));l&&l.registerEvents(n);
n&&n.registerEvents(l);var v=function(){l&&C(l);n&&C(n)};g.on(window,"resize",v);var r=setInterval(function(){for(var a=q.parentNode;a&&a!=document.body;a=a.parentNode);a||(clearInterval(r),g.off(window,"resize",v))},5E3)};K.prototype={constructor:K,editor:function(){return this.edit},rightOriginal:function(){return this.right&&this.right.orig},leftOriginal:function(){return this.left&&this.left.orig},setShowDifferences:function(a){this.right&&this.right.setShowDifferences(a);this.left&&this.left.setShowDifferences(a)},
rightChunks:function(){if(this.right)return m(this.right),this.right.chunks},leftChunks:function(){if(this.left)return m(this.left),this.left.chunks}};var Q,ia=1,D=2,J=4;S.prototype={signal:function(){g.signal(this,"realign");this.height=this.cm.doc.height},set:function(a,b){for(var c=-1;c<this.alignable.length;c+=2){var d=this.alignable[c]-a;if(0==d){if((this.alignable[c+1]&b)==b)return;this.alignable[c+1]|=b;this.signal();return}if(0<d)break}this.signal();this.alignable.splice(c,0,a,b)},find:function(a){for(var b=
0;b<this.alignable.length;b+=2)if(this.alignable[b]==a)return b;return-1},check:function(a,b,c){var d=this.find(a);-1!=d&&this.alignable[d+1]&b&&!c.call(this,a)&&(this.signal(),(a=this.alignable[d+1]&~b)?this.alignable[d+1]=a:this.alignable.splice(d,2))},hasMarker:function(a){a=this.cm.getLineHandle(a);if(a.markedSpans)for(var b=0;b<a.markedSpans.length;b++)if(a.markedSpans[b].mark.collapsed&&null!=a.markedSpans[b].to)return!0;return!1},hasWidget:function(a){a=this.cm.getLineHandle(a);if(a.widgets)for(var b=
0;b<a.widgets.length;b++)if(!a.widgets[b].above&&!a.widgets[b].mergeSpacer)return!0;return!1},hasWidgetBelow:function(a){if(a==this.cm.lastLine())return!1;a=this.cm.getLineHandle(a+1);if(a.widgets)for(var b=0;b<a.widgets.length;b++)if(a.widgets[b].above&&!a.widgets[b].mergeSpacer)return!0;return!1},map:function(a,b,c){for(var d=c-b,f=a+b,e=b=-1,g=0;g<this.alignable.length;g+=2){var h=this.alignable[g];h==a&&this.alignable[g+1]&D&&(b=g);h==f&&this.alignable[g+1]&D&&(e=g);h<=a||(h<f?this.alignable.splice(g--,
2):this.alignable[g]+=d)}-1<b&&(d=this.alignable[b+1],d==D?this.alignable.splice(b,2):this.alignable[b+1]=d&~D);-1<e&&c&&this.set(a+c,D)}};g.commands.goNextDiff=function(a){return ja(a,1)};g.commands.goPrevDiff=function(a){return ja(a,-1)}});
